=== modified file 'docs/index.rst'
--- docs/index.rst	2010-03-23 15:44:51 +0000
+++ docs/index.rst	2010-03-23 20:12:50 +0000
@@ -3,73 +3,120 @@
 
 Loggerhead is a web viewer for projects in bazaar. It can be used to navigate 
 a branch history, annotate files, view patches, perform searches, etc.
-It is heavily based on ``bazaar-webserve``, which is itself based on ``hgweb``
-for Mercurial.
+oggerhead is heavily based on `bazaar-webserve
+<https://launchpad.net/bzr-webserve>`_, which was, in turn, loosely
+based on `hgweb <http://mercurial.selenic.com/wiki/HgWebDirStepByStep>`_.
+
 
 Getting Started
 ---------------
 
-Loggerhead depends on:
-
-1) SimpleTAL for templating.
-   On Ubuntu, ``sudo apt-get install python-simpletal``
-   or download from http://www.owlfish.com/software/simpleTAL/download.html
-
-2) simplejson for producing JSON data.
-   On Ubuntu, ``sudo apt-get install python-simplejson``
-   or use `easy_install simplejson`.
-
-3) Paste for the server. (You need version 1.2 or newer of Paste.)
-   On Ubuntu, ``sudo apt-get install python-paste``
-   or use `easy_install Paste`
-
-4) Paste Deploy  (optional, needed when proxying through Apache)
-   On Ubuntu, ``sudo apt-get install python-pastedeploy``
-   or use `easy_install PasteDeploy`
-
-5) flup (optional, needed to use FastCGI, SCGI or AJP)
-   On Ubuntu, ``sudo apt-get install python-flup``
-   or use `easy_install flup`
-
-Then simply run the 'serve-branches' with the branch you want to
-serve on the command line:
+Loggerhead depends on the following Python libraries.:
+
+- SimpleTAL for templating.
+
+- simplejson for producing JSON data.
+
+- Paste for the server. (You need version 1.2 or newer of Paste.)
+
+- Paste Deploy  (optional, needed when proxying through Apache)
+
+- flup (optional, needed to use FastCGI, SCGI or AJP)
+
+
+Installing Dependencies Using Ubuntu Packages
+#############################################
+
+.. code-block:: sh
+
+   $ sudo apt-get install python-simpletal
+   $ sudo apt-get install python-simplejson
+   $ sudo apt-get install python-paste
+   $ sudo apt-get install python-pastedeploy
+   $ sudo apt-get install python-flup
+
+Installing Dependencies Using :command:`easy_install`
+#####################################################
+
+.. code-block:: sh
+
+   $ easy_install \
+     -f http://www.owlfish.com/software/simpleTAL/py2compatible/download.html \
+     SimpleTAL
+   $ easy_install simplejson
+   $ easy_install Paste
+   $ easy_install PasteDeploy
+   $ easy_install flup
+
+
+Running the Standalone Loggerhead Server
+----------------------------------------
+
+After installing all the dependencies, you should be able to run
+:command:`serve-branches` with the branch you want to serve on the
+command line:
 
 .. code-block:: sh
 
     ./serve-branches ~/path/to/branch
 
-The script listens on port 8080 so head to http://localhost:8080/ in
-your browser to see the branch.  You can also pass a directory that
-contains branches to the script, and it will serve a very simple
-directory listing at other pages.
+By default, the script listens on port 8080, so head to
+http://localhost:8080/ in your browser to see the branch.
+
+You can also pass a directory that contains branches to the script,
+and it will serve a very simple directory listing at other pages.
 
 You may update the Bazaar branches being viewed at any time.
 Loggerhead will notice and refresh, and Bazaar uses its own branch
 locking to prevent corruption.
 
+See :doc:`serve-branches` for all command line options.
+
+Running Loggerhead as a Daemon
+------------------------------
+
 To run loggerhead as a linux daemon:
 
-1) Copy loggerheadd to ``/etc/init.d``
+1) Copy the ``loggerheadd`` scipt to ``/etc/init.d``
+
+.. code-block:: sh
+
+   $ sudo cp ./loggerheadd /etc/init.d
 
 2) Edit the file to configure where your loggerhead is installed, and which
    serve-branches options you would like.
 
+.. code-block:: sh
+
+   $ sudo vim /etc/init.d/loggerheadd
+
 3) Register the service
-   ``cd /etc/init.d``
-
-   a) on upstart based systems like Ubuntu run: 
-      ``update-rc.d loggerheadd defaults``
-
-   b) on Sysvinit based systems like Centos or SuSE run:
-      ``chkconfig --add loggerheadd``
-
-
-Loggerhead as a Bazaar Plugin
------------------------------
+
+a) on upstart based systems like Ubuntu run: 
+
+.. code-block:: sh
+
+   $ sudo update-rc.d loggerheadd defaults
+
+b) on Sysvinit based systems like Centos or SuSE run:
+
+.. code-block:: sh
+
+   $ sudo chkconfig --add loggerheadd
+
+
+Using Loggerhead as a Bazaar Plugin
+------------------------------------
 
 This branch contains experimental support for using Loggerhead as a Bazaar
 plugin.  To use it, place the top-level Loggerhead directory (the one
-containing this file) at ``~/.bazaar/plugins/loggerhead``.
+containing this file) at ``~/.bazaar/plugins/loggerhead``.  E.g.:
+
+.. code-block:: sh
+
+   $ bzr branch lp:loggerhead ~/.bazaar/plugins/loggerhead
+   $ cd ~/myproject
+   $ bzr serve --http
 
 
 Using a Config File
@@ -83,12 +130,11 @@
     [/path/to/branch]
     http_serve = False
 
-
 More configuration options to come soon.
 
 
-Serving Loggerhead from Behind Apache
--------------------------------------
+Serving Loggerhead behind Apache
+--------------------------------
 
 If you want to view Bazaar branches from your existing Apache
 installation, you'll need to configure Apache to proxy certain
@@ -112,17 +158,27 @@
 ------
 
 Search is currently supported by using the bzr-search plugin (available
-at: ``https://launchpad.net/bzr-search``
+at: https://launchpad.net/bzr-search ).
+
 You need to have the plugin installed and each branch indexed to allow
 searching on branches.
 
+Command-Line Reference
+----------------------
+
+.. toctree::
+   :maxdepth: 2
+
+   serve-branches
+   start-loggerhead
+   stop-loggerhead
+
 
 Support
 -------
 
-Loggerhead is loosely based on bazaar-webserve, which was loosely
-based on hgweb.  Discussion should take place on the bazaar-dev
-mailing list at bazaar@lists.canonical.com.  You can join the list at
+Discussion should take place on the bazaar-dev mailing list at
+mailto:bazaar@lists.canonical.com.  You can join the list at
 <https://lists.ubuntu.com/mailman/listinfo/bazaar>.  You don't need to
 subscribe to post, but your first post will be held briefly for manual
 moderation.
@@ -135,13 +191,14 @@
 Hacking
 -------
 
-To run loggerhead tests, you will need the package python-nose,
-and run in the loggerhead directory:
+To run loggerhead tests, you will need to install the package ``python-nose``,
+and run its :command:`nosetests` script in the loggerhead directory:
 
 .. code-block:: sh
 
     nosetests
 
+
 License
 -------
 
@@ -152,19 +209,7 @@
 
 https://launchpad.net/loggerhead
 
-Contents:
-
-.. toctree::
-   :maxdepth: 2
-
-   serve-branches
-   start-loggerhead
-   stop-loggerhead
-
-Indices and tables
-==================
-
-* :ref:`genindex`
-* :ref:`modindex`
-* :ref:`search`
-
+Index
+=====
+
+- :ref:`genindex`

=== modified file 'docs/serve-branches.rst'
--- docs/serve-branches.rst	2010-03-23 15:44:51 +0000
+++ docs/serve-branches.rst	2010-03-23 19:54:47 +0000
@@ -1,7 +1,7 @@
-:command:`serve-branches`:  Run a loggerhead server [XXX in the foreground]
-===========================================================================
+:command:`serve-branches`
+=========================
 
-The :command:`serve-branches` command runs a standalone loggerhead server in
+The :command:`serve-branches` script runs a standalone loggerhead server in
 the foreground.
 
 .. program:: serve-branches
@@ -13,39 +13,103 @@
 
    serve-branches [OPTIONS] <target directory>
 
-.. cmdoption:: -h, --help
-
-    Show this help message and exit
+Options
+-------
 
 .. cmdoption:: --user-dirs
 
-    Serve user directories as ``~user``. XXX (Requires ``--trunk-dir``).
+    Serve user directories as ``~user`` (requires ``--trunk-dir``).
+
+    If both options are set, then for requests where the CGI ``PATH_INFO``
+    starts with "/~<name>", serve branches under the <name> directory.
 
 .. cmdoption:: --trunk-dir=DIR
 
-    The directory that contains the trunk branches.
+    The directory that contains the trunk branches (requires ``--user-dirs``).
+
+    If both options are set, then for requests where the CGI ``PATH_INFO``
+    does not start with "/~<name>", serve branches under DIR.
 
 .. cmdoption:: --port
 
-    Port Loggerhead should listen on (defaults to 8080).
+    Listen on the given port.
+    
+    Defaults to 8080.
 
 .. cmdoption:: --host
 
-    Host Loggerhead should listen on. XXX (defaults to 0.0.0.0).
+    Listen on the interface corresponding to the given IP. 
+    
+    Defaults to listening on all interfaces, i.e., "0.0.0.0".
+
+.. cmdoption:: --protocol
+
+    Serve the application using the specified protocol.
+    
+    Can be one of: "http", "scgi", "fcgi", "ajp" (defaults to "http").
 
 .. cmdoption:: --prefix
 
-    Specify host prefix. XXX this is wildly unclear.
-
-.. cmdoption:: --reload
-
-    Restarts the application when changing python files. Only used for
-    development purposes.
+    Set the supplied value as the CGI ``SCRIPT_NAME`` for the application.
+
+    This option is intended for use when serving Loggerhead behind a
+    reverse proxy, with Loggerhead being "mounted" at a directory below
+    the root.  E.g., if the reverse proxy translates requests for
+    ``http://example.com/loggerhead`` onto the standalone Loggerhead process,
+    that process should be run with ``--prefix=/loggerhead``.
 
 .. cmdoption:: --log-folder=LOG_FOLDER
 
-    The directory [XXX in which] to place log files
+    The directory in which to place loggerhead's log files.
+    
+    Defaults to the current directory.
+
+.. cmdoption:: --cache-dir=SQL_CACHE_DIR
+
+    The directory in which to place the SQL cache.
+
+    Defaults to the current directory.
+
+.. cmdoption:: --use-cdn
+   
+    Serve YUI javascript libraries from Yahoo!'s CDN.
+
+.. cmdoption:: --allow-writes
+   
+    Allow writing to the Bazaar server.
+    
+    Setting this option keeps loggerhead from adding a 'readonly+' prefix
+    to the base URL of is to make visible the display of instructions for
+    checking out the 'public_branch' URL for the branch being browsed.
+
+.. cmdoption:: -h, --help
+
+    Print the help message and exit
 
 .. cmdoption:: --version
 
     Print the software version and exit.
+
+Debugging Options
+-----------------
+
+The following options are only useful when developing / debugging Loggerhead
+itself.
+
+.. cmdoption:: --profile
+   
+    Generate per-request callgrind profile data.
+    
+    Data for each request is written to a file ``%d-stats.callgrind``,
+    where ``%d`` is replaced by the sequence number of the request.
+
+.. cmdoption:: --memory-profile
+
+    Profile the memory usage using the `Dozer
+    <http://pypi.python.org/pypi/Dozer>`_ middleware.
+
+.. cmdoption:: --reload
+
+    Restart the application when any of its python file change.
+    
+    This option should only used for development purposes.

=== modified file 'docs/start-loggerhead.rst'
--- docs/start-loggerhead.rst	2010-03-23 15:44:51 +0000
+++ docs/start-loggerhead.rst	2010-03-23 19:54:47 +0000
@@ -1,8 +1,8 @@
-:command:`start-loggerhead`:  Start a loggerhead server [XXX as a daemon]
-=========================================================================
+:command:`start-loggerhead`
+===========================
 
 The :command:`start-loggerhead` command starts a new standalone loggerhead
-server [XXX in the background (daemonized) by default]
+server.  By default, the server runs in the background (daemonized).
 
 .. program:: start-loggerhead
 
@@ -13,6 +13,9 @@
 
    start-loggerhead [OPTIONS]
 
+Options
+-------
+
 .. cmdoption:: --version
 
     Print the software version and exit.

=== modified file 'docs/stop-loggerhead.rst'
--- docs/stop-loggerhead.rst	2010-03-23 15:44:51 +0000
+++ docs/stop-loggerhead.rst	2010-03-23 19:54:47 +0000
@@ -1,8 +1,8 @@
-:command:`stop-loggerhead`:  Stop a [XXX daemonized] loggerhead server 
+:command:`stop-loggerhead`
 ======================================================================
 
 The :command:`stop-loggerhead` command stops the currently running loggerhead
-server.
+daemon.
 
 .. program:: stop-loggerhead
 

